#!/bin/sh
spitshell=cat
package=IRC

echo "Extracting src/version.c..."

if test -r version.c.last
then
	generation=`sed -n 's/^char \*generation = \"\(.*\)\";/\1/p' < version.c.last`
if test ! "$generation" ; then generation=0; fi
else
	generation=0
fi

generation=`expr $generation + 1`

uname=`uname -a`

creation=`date | awk '{if (NF == 6) { print $1 " "  $2 " " $3 " "  $6 " at " $4 " " $5 } else { print $1 " "  $2 " " $3 " " $7 " at " $4 " " $5 " " $6 }}'`

$spitshell >version.c <<!SUB!THIS!
/*
 *  UltimateIRCd - an Internet Relay Chat Daemon, src/version.c.SH
 *
 *  Copyright (C) 2002 by the past and present ircd coders, and others.
 *  Refer to the documentation within doc/authors/ for full credits and copyrights.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 *  USA
 *
 *  $Id: version.c.SH,v 1.12 2002/10/19 05:48:20 shadowmaster Exp $
 *
 */

/*
 * This file is generated by version.c.SH. Any changes made will go away.
 */

#include "struct.h"
#include "version.h"

char *generation = "$generation";
char *creation = "$creation";
char version[128];
char protoctl[512];


/*
** No Name or entry in this list should EVER be removed
*/

char *creditstext[] =
    {

	"IRC --",
	"Copyright (C) 2002 by the past and present ircd coders, and others.",
	"",
	0,
    };


char *copyrighttext[] =
    {
 	"Copyright (C) 2002 by the past and present ircd coders, and others.",
      	"Refer to the documentation within doc/authors/ for full credits and copyrights.",
	"",
	"This program is free software; you can redistribute it and/or modify",
	"it under the terms of the GNU General Public License as published by",
	"the Free Software Foundation; either version 2 of the License, or",
	"(at your option) any later version.",
	"",
	"This program is distributed in the hope that it will be useful,",
	"but WITHOUT ANY WARRANTY; without even the implied warranty of",
	"MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the",
	"GNU General Public License for more details.",
	"",
	"A copy of the GNU General Public License is distributed with all",
	"official releases of ShadowIRCd. It can also be obtained by writing to",
	"Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,",
	"MA  02111-1307 USA",
	 0,
};


!SUB!THIS!
